/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * capitol.c -- designate a capitol
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>

int capitol_racedata;

capitol(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int shipno,stat;
int shdata;
shiptype *s;

free(Race);
openracedata(&capitol_racedata);
getrace(capitol_racedata, &Race, Playernum);
close_file(capitol_racedata);

  if (argn!=2) {

     shipno = Race->Gov_ship;

  } else {

     shipno = atoi(args[1]+(args[1][0]=='#'));

     if (Dir[Playernum-1].level==LEVEL_UNIV) {
	 if (!enufAP(Playernum,Sdata.AP[Playernum-1],APcount))
		return;
     } else {
	 if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1],APcount))
		return;
     }
  }

if(shipno <= 0) {
	notify(Playernum, "Change the capitol to be what ship?\n");
	return;
	}

  openshdata(&shdata);
  stat = getship(shdata, &s, shipno);
  close_file(shdata);

  if (argn==2) {
    if (!stat || testship(Playernum,s, shipno))
	return;

    if (s->type!=OTYPE_GOV) {
	sprintf(buf,"That ship is not a %s.\n",Shipnames[OTYPE_GOV]);
	notify(Playernum, buf);
	return;
    }

    if (Dir[Playernum-1].level==LEVEL_UNIV)
	  deductAPs(Playernum, APcount, 0, 1);
    else
	  deductAPs(Playernum, APcount, Dir[Playernum-1].snum, 0);

    Race->Gov_ship = shipno;
openracedata(&capitol_racedata);
    putrace(capitol_racedata, Race);
close_file(capitol_racedata);

  }
  sprintf(buf,"Efficiency of governmental center: %.0f%%.\n", 
	((float)s->popn/Max_crew(s)) *
	(100 - (float)s->damage) );
  notify(Playernum, buf);

  free(s);

}
