/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB.c, enroll.dat.
 * Restrictions in GB.c.
 */


struct race {
    int Playernum;
    char name[RNAMESIZE];
    float tech;		/* technology */
    float birthrate;
    float overbirthrate;
    percent fighters;
    percent IQ;
    percent number_sexes;
    float mass;
    float metabolism;
    float adventurism;
    short conditions[OTHER+1];	/* planetary conditions you like */
    char deflevel;
    char defsystem;
    char defplanetnum;	/* current default */
    char homelevel;
    char homesystem;
    char homeplanetnum;	/* home place */
    float likes[DES_PLATED+1];		/* what territories they like */
    char likesbest;
    percent translate[MAXPLAYERS];	/* translation mod for each player */
    percent captured_prisoners[MAXPLAYERS]; /* goes up with planetary contact */
    unsigned int atwar;		/* war 32 bits*/
    unsigned int allied;	/* allies 32 bits*/
    unsigned short Gov_ship;
    int double_digits;		/* options for 'toggle' */
    int inverse;
    int geography;
    int autoload;
    int C_C;			/* berserker control code */
    short God;		/* whether or not the race has God status */
    unsigned Thing : 1;			/* your race is like "The Thing" */
};

struct block {
    int Playernum;
    char name[RNAMESIZE];
    unsigned int invite;
    unsigned int pledge;
    unsigned int atwar;
    unsigned int allied;
    unsigned VPs;
};

struct power_blocks {
	char time[128];
	unsigned members[MAXPLAYERS];
	ul popn[MAXPLAYERS];	/* total population */
	ul resource[MAXPLAYERS];	/* total resource in stock */
	ul fuel[MAXPLAYERS];
	ul destruct[MAXPLAYERS];	/* total dest in stock */
	us ships_owned[MAXPLAYERS];	/* # of ships owned */
	us planets_owned[MAXPLAYERS];
	ul sectors_owned[MAXPLAYERS];
	us VPs[MAXPLAYERS];
};

typedef struct race racetype;
typedef struct block blocktype;
EXTERN struct block Blocks[MAXPLAYERS];
EXTERN struct power_blocks Power_blocks;

EXTERN racetype *Race;
EXTERN racetype *races[MAXPLAYERS];
